unit OL_Pages_IMPL;

interface

uses
  ComObj, ComServ, ActiveX, Variants, adxAddIn, OL_Pages_TLB,
  Outlook2000, StdVcl;

type
  TOL_Addin = class(TadxAddin, IOL_Addin)
  end;

  TAddInModule = class(TadxCOMAddInModule)
    procedure adxCOMAddInModuleAddInInitialize(Sender: TObject);
    procedure adxCOMAddInModuleAddInFinalize(Sender: TObject);
  private
  protected
    procedure OptionsPagesAdd(ASender: TObject;
      const Pages: PropertyPages); override;
    procedure NameSpaceOptionsPagesAdd(ASender: TObject;
      const Pages: PropertyPages; const Folder: MAPIFolder); override;
  public
  end;

var
  adxOL_Addin: TAddInModule;

implementation

{$R *.dfm}

procedure TAddInModule.OptionsPagesAdd(ASender: TObject; const Pages: PropertyPages);
begin
  Pages.Add('OL_Pages.adxOptionPage', 'My Option Page');
end;

procedure TAddInModule.NameSpaceOptionsPagesAdd(ASender: TObject;
  const Pages: PropertyPages; const Folder: MAPIFolder);

  function GetFullFolderName(const AFolder: MAPIFolder): string;
  var
    IDisp: IDispatch;
    Folder: MAPIFolder;
  begin
    Result := '';
    Folder := AFolder;
    while Assigned(Folder) do begin
      Result := '\' + Folder.Name + Result;
      IDisp := Folder.Parent;
      IDisp.QueryInterface(IID_MAPIFolder, Folder);
    end;
    if Result <> '' then Delete(Result, 1, 1);
  end;

begin
  if GetFullFolderName(Folder) = 'Personal Folders\Inbox' then
    Pages.Add('OL_Pages.adxPropPage', 'My Inbox Property Page');
end;

procedure TAddInModule.adxCOMAddInModuleAddInInitialize(Sender: TObject);
begin
  adxOL_Addin := self;
end;

procedure TAddInModule.adxCOMAddInModuleAddInFinalize(Sender: TObject);
begin
  if Assigned(adxOL_Addin) then adxOL_Addin := nil;
end;

initialization
  TadxFactory.Create(ComServer, TOL_Addin, CLASS_OL_Addin, TAddInModule);

end.
